#include <cmath>
#include <iostream>
#include <numeric>

class fraction {
	int num, denom;

public:
	fraction(int num = 0, int denom = 1)
	  : num(num), denom(denom) { normalize(); }

	operator double() const {
		return static_cast<double>(num) / denom;
	}

private:
	void normalize() {
		int d = std::gcd(num, denom);
		num /= d;
		denom /= d;
	}
};

int main() {
	fraction one = 1;  // the same as = { 1 }
	fraction pi_approx = { 22, 7 };

	double d_one = one;
	double d_pi = pi_approx;

	std::cout << d_one << ' ' << d_pi << '\n';

	std::cout << std::sqrt(pi_approx) << '\n';

	std::cout << one + 2 << '\n';
}
