#include <iostream>
#include <vector>

void print(const auto& vec) {
	if (vec.empty()) {
		std::cout << "{}\n";
		return;
	}
	auto sep = "{ ";
	for (auto& x : vec) {
		std::cout << sep << x;
		sep = ", ";
	}
	std::cout << " }\n";
}

using int_pred = bool(int);

std::vector<int> filter(const std::vector<int>& vec,
                        int_pred* pred) {
	std::vector<int> result;
	for (int x : vec)
		if (pred(x))
			result.push_back(x);
	return result;
}

bool even(int num) { return num % 2 == 0; }
bool less7(int num) { return num < 7; }

int main() {
	std::vector v = { 1, 2, 3, 4, 5, 6, 7, 8, 9 };
	auto fv = filter(v, even);
	print(fv);
	print(filter(v, less7));
}
