#include <iostream>
#include <map>
#include <vector>

void print(const auto& vec) {
	if (vec.empty()) {
		std::cout << "{}\n";
		return;
	}
	auto sep = "{ ";
	for (auto& x : vec) {
		std::cout << sep << x;
		sep = ", ";
	}
	std::cout << " }\n";
}

auto filter(const auto& cont, auto pred) {
	using T = std::decay_t<decltype(*cont.begin())>;
	std::vector<T> result;
	for (auto& x : cont)
		if (pred(x))
			result.push_back(x);
	return result;
}

bool even(int num) { return num % 2 == 0; }

bool snd(std::pair<const char, bool> p) {
	auto [c, b] = p;
	return b;
}

int main() {
	std::vector v = { 1, 2, 3, 4, 5, 6, 7, 8, 9 };
	print(filter(v, even));

	std::map<char, bool> m = {
		{'a', true}, {'c', false}, {'x', true}, {'z', false}
	};

	auto fv = filter(m, snd);
	for (auto& p : fv) {
		auto [c, b] = p;
		std::cout << c;
	}
	std::cout << '\n';
}
