#include <iostream>

void foo(int num) {
	std::cout << "foo(" << num << ")\n";
}

void bar(int num) {
	std::cout << "bar(" << num << ")\n";
}

void gen(auto num) {
	std::cout << "gen(" << num << ")\n";
}

void over(int num) {
	std::cout << "over(" << num << ")\n";
}
void over(bool, char) {}


int main() {
	// classic (C-like)
	void (*ptr1)(int) = foo;
	ptr1(1);

	// better: using aliases
	using fun = void(int);
	using fun_ptr = fun*;
	fun_ptr ptr2 = foo;
	ptr2(2);

	// even better: auto
	// (note: * not needed here due to implicit decay)
	auto* ptr3 = foo;
	ptr3(3);

	// (note: & not needed here due to implicit conversion)
	ptr3 = &bar;
	ptr3(3);

	// these are OK:
	fun_ptr ptr4 = gen;
	ptr4(4);
	fun_ptr ptr5 = over;
	ptr5(5);

	// auto* ptr6 = gen; // error
	// auto* ptr7 = over; // error
}
