#include <stdexcept>
#include <iostream>
#include <vector>

const int DARK = 0;
const int LIGHT = 1;
const int BY_TIME = 2;

struct preferences {
	int mode;
};

preferences get_user_preferences() {
	return { DARK };
}

int get_time_of_day() {
	return 13 * 3600 + 30 * 60;
}

int main() {
	std::vector nums = { 1, 3, 3, 7, 42 };

	const int sum = [&] {
		int sum = 0;
		for (int num : nums) {
			sum += num;
		}
		return sum;
	}();

	// sum += 1;  // sum is const, we cannot modify it

	std::cout << sum << '\n';

	auto [r, g, b] = [] {
		auto p = get_user_preferences();
		bool light = p.mode == LIGHT;
		if (p.mode == BY_TIME) {
			int time = get_time_of_day();
			light = 6 * 3600 < time && time < 20 * 3600;
		}
		return light ? std::tuple{ 255, 255, 255 }
		             : std::tuple{ 0, 0, 0 };
	}();

	std::cout << r << ' ' << g << ' ' << b << '\n';

	int& first_even = [&]() -> int& {  // () can be omitted in C++23
		for (int& num : nums) {
			if (num % 2 == 0) {
				return num;
			}
		}
		throw std::runtime_error("no even numbers");
	}();

	first_even = 0;
	for (int num : nums) {
		std::cout << num << ' ';
	}
	std::cout << '\n';

	int traffic_light = 0;
	auto colour = [&] { switch (traffic_light) {
		case 0: return "RED";
		case 1: return "YELLOW";
		case 2: return "GREEN";
		case 3: return "RED+YELLOW";
		default: return "bad colour";
	} }();

	std::cout << colour << '\n';
}
