#include <iostream>
#include <memory>

struct node {
	using ptr = std::unique_ptr<node>;
	int value;
	ptr left, right;

	void preorder(auto& fun) {
		fun(value);
		if (left) left->preorder(fun);
		if (right) right->preorder(fun);
	}
};

struct tree {
	node::ptr root;

	void preorder_visit(auto fun) {
		if (root) root->preorder(fun);
	}
};

int main() {
	tree t = {
		std::make_unique<node>(1,
			std::make_unique<node>(2,
				std::make_unique<node>(3),
				std::make_unique<node>(4)
			),
			std::make_unique<node>(5,
				std::make_unique<node>(6),
				std::make_unique<node>(7)
			)
		)
	};

	t.preorder_visit([](int x){ std::cout << x << '\n'; });

	int sum = 0;
	t.preorder_visit([&](int x){ sum += x; });
	std::cout << "sum: " << sum << '\n';

	t.preorder_visit([s = 0](int x) mutable {
		s += x; std::cout << s << '\n';
	});
}
